export declare const __get: unique symbol;
export declare const __set: unique symbol;
export declare const __has: unique symbol;
export declare const __delete: unique symbol;
export declare const __invoke: unique symbol;
export interface MagicalClass {
    __get?(prop: string | symbol): any;
    __set?(prop: string | symbol, value: any): void;
    __has?(prop: string | symbol): boolean;
    __delete?(prop: string | symbol): void;
    /** @deprecated */
    __invoke?(...args: any[]): any;
}
export declare function applyMagic<T extends new (...args: any[]) => any>(ctor: T): T;
export declare function applyMagic<T extends (...args: any[]) => any>(fn: T, proxyOnly: boolean): T;
export declare function applyMagic<T extends object>(obj: T): T;
